#ifndef _Function_pointer_h
#define _Function_pointer_h 

#include <ctime>

class Meal {
public:
    static const std::tm Defaut_moment; // '#include <ctime>'

    enum Meal_type {
        Breakfast, Lunch, Afternoon_tea, Dinner
    };
private:
    enum Meal_type _type;
    std::tm _moment;
public:
    Meal(enum Meal_type = Breakfast, const std::tm& = Defaut_moment);
    const std::tm& moment() const;
    // It's useful to setup the type of the member function:
    typedef const std::tm& (Meal::*Moment_type)() const;
};

#endif          
